#define JEDNA (((unsigned char)255) >> 7)
#define CSL 6

char *identstring;

//: sltypy

#define SL_NULL    0  // nic
#define SL_BOOL    1  // pravdivostni hodnota  - - - - - -  funkce save_bit
#define SL_TRIT    2  // zaporne/nula/kladne  - - - - - - - funkce save_trit
#define SL_CHAR    3  // znak  - - - - - - - - - - - - - -  funkce save_char
#define SL_INT     4  // cele cislo - - - - - - - - - - - - funkce save_int
#define SL_FLOAT   5  // castecne realne cislo - - - - - -  funkce save_float
#define SL_COLOR   6  // ukazatel na aktualni barvu - - - - funkce save_color
#define SL_PIXMAP  7  // ukazatel na pixmapu - - - - - - -  funkce save_pixmap
#define SL_WIDGET  8  // ukazatel na widget - - - - - - - - funkce save_widget
#define SL_SUBMAP  9  // ukazatel na submapu - - - - - - -  funkce save_submap
#define SL_ANIP   10  // ukazatel na animaci postavy  - - - funkce save_anip
#define SL_POST   11  // ukazatel na postavu - - - - - - -  funkce save_post
#define SL_TIMER  12  // ukazatel na timer  - - - - - - - - funkce save_timer
#define SL_POL    13  // ukazatel na policko - - - - - - -  funkce save_pol
#define SL_PREDM  14  // ukazatel na predmet  - - - - - - - funkce save_predmet
#define SL_WORD   15  // ukazatel na slovo - - - - - - - -  funkce save_word
#define SL_AWID   16  // ukazatel na animwid  - - - - - - - funkce save_awid
#define SL_FUNC   17  // ukazatel na funkci  - - - - - - -  funkce save_func

//: sl_func

struct sl_func{
  char typ;
  void (*funkce)();
  sl_func *next;
};

sl_func *prvslfunc;
int pocet_func;

//: sl_var

struct sl_var{
  char typ;
  void *ukazatel;
  union{
    char ch;
    int i;
    float f;
    void *p;
  } loaded;

  sl_var *next;
};

//: prvslvar

sl_var *prvslvar;

//: protypy

void init_sl();
void zapiscs(char co, char *cs, int *cspos, int delka);

void save_start(char *filename);
void save_end();
void save_idstr();
void save_cs();
void save_bit(char b);
void save_trit(char t);
void save_char(char ch);
void save_unsint(unsigned int i);
void save_int(int i);
void save_string(char *str);
void save_float(float f);

void save_pocty();
void save_color(kq_color *c);
void save_pointer(void *p, char typ);
void save_func(void (*f)(), kq_pin *parametr);
void add_sl_func(void (*f)(), char typ);
void add_sl_var(void *p, char typ);
void save_vars();
void save_kontexts();
void save_word(kq_word *w);
void save_pixmaps();
void save_pixmap(kq_pixmap *pxm);
void save_winfo(kq_widget *w);
void save_widgets();
void save_widget(kq_widget *w);
void save_sminfo(kq_submap *sm);
void save_submaps();
void save_submap(kq_submap *sm);
void save_anips();
void save_anip(kq_animpost *anip);
void save_posts();
void save_post(kq_postava *post);
void save_predmets();
void save_predmet(kq_predmet *p);
void save_awids();
void save_awid(kq_anim *p);
void save_tinfo(kq_timer *tim);
void save_timers();
void save_timer(kq_timer *tim);
void save_pol(kq_policko *pol);

void save_all(char *filename);
void save_conf();
